
(define-type Tree
  [leaf (name symbol?)]
  [node (left Tree?)
        (right Tree?)])

;; find : sym Tree -> false-or-list-of-sym
(define (find name t)
  (type-case Tree t
    [leaf (name2) (if (eq? name name2)
                      empty
                      false)]
    [node (l r)
          (local [(define at-l (find name l))]
            (if (list? at-l)
                (cons 'left at-l)
                (local [(define at-r (find name r))]
                  (if (list? at-r)
                      (cons 'right at-r)
                      false))))]))

(test (find 'hello (node (node (leaf 'bye) (leaf 'adios)) 
                         (node (leaf 'see-ya) (leaf 'later))))
      false)

(test (find 'hello (node (node (leaf 'bye) (leaf 'adios)) 
                         (node (leaf 'hello) (leaf 'hi))))
      '(right left))


;; find/k : sym Tree (list-of-sym -> alpha) (-> alpha) -> alpha
(define (find/k name t success-k fail-k)
  (type-case Tree t
    [leaf (name2) (if (eq? name name2)
                      (success-k empty)
                      (fail-k))]
    [node (l r)
          (find/k name l
                  (lambda (at-l)
                    (success-k (cons 'left at-l)))
                  (lambda ()
                    (find/k name r
                            (lambda (at-r)
                              (success-k (cons 'right at-r)))
                            fail-k)))]))

(test (find/k 'hello (node (node (leaf 'bye) (leaf 'adios)) 
                           (node (leaf 'see-ya) (leaf 'later)))
              (lambda (l) (list 'found l))
              (lambda () '(nope)))
      '(nope))

(test (find/k 'hello (node (node (leaf 'bye) (leaf 'adios)) 
                           (node (leaf 'hello) (leaf 'hi)))
              (lambda (l) (list 'found l))
              (lambda () '(nope)))
      '(found (right left)))


                      